


<?include "torrent_config.php";?>

<html>
<head>
<meta http-equiv="refresh" content="<?=$refresh?>" />

<head>
  <title> ECTC - Enhanced CTorrent Control </title>
</head>

<body>

<?php 

class torrent_sum_class
{
  var $total = 0;
  var $running = 0;
  var $scheduled = 0;
}

$torrent_sum = new torrent_sum_class();

//$torrent_count = 0;
//$running_torrents = 0;
//$scheduled_torrents = 0;


class torrent_class // Torrent Class
{


	var $name;
	var $pid;
	var $stats=""; 
	var $schedule_nr; 
  var $history="";
  var $meta_info="";
  

  

	var $state = 0; // 1=loaded; 2=running; 3=done; 4=scheduled; 5=seeding
	function status()
	{
    global $status_name_running;
    global $status_name_loaded;
    global $status_name_stopped;
    global $status_name_scheduled;
    global $status_name_seeding;
  
		$state_string="ILLEGAL";
		switch($this->state)
		{
			case 1: //loaded
			$state_string = $status_name_loaded;
			break;

			case 2: //running
			$state_string = $status_name_running ;
			break;

			case 3: //done
			$state_string = $status_name_stopped;
			break;

			case 4: // scheduled
			$state_string = $status_name_scheduled;
			break;
      
			case 5: // seeding
			$state_string = $status_name_seeding;
			break;

		}
		return $state_string;
	}
  
	function status_colour()
	{
    global $status_colour_running;
    global $status_colour_loaded;
    global $status_colour_stopped;
    global $status_colour_scheduled;
    global $status_colour_seeding; 
  
		$colour_string="black";
		switch($this->state)
		{
			case 1: //loaded
			$colour_string = $status_colour_loaded;
			break;

			case 2: //running
			$colour_string = $status_colour_running;
			break;

			case 3: //done
			$colour_string = $status_colour_stopped;
			break;

			case 4: // scheduled
			$colour_string = $status_colour_scheduled;
			break;
      
			case 5: // seeding
			$colour_string = $status_colour_seeding;
			break;

		}
		return $colour_string;
	}
  
  
}

function all_pids_of_running_torrents()
{
	/* 
	Get all "ps -ef" lines in which a torrent is involved
	*/
	$allpids = explode ("\n", shell_exec("/bin/ps -ef | /bin/grep ctorrent"));
	return $allpids;
}


function all_scheduled_torrents()
{
	global $absolute_path;
	
	if (!file_exists($absolute_path."/scheduled_torrents.txt")) return array("0"=> "");
  
	return  file ($absolute_path."/scheduled_torrents.txt");

}






function pidof($allpids, $name)
{
	/* 
	This extracts the PID out of the "ps-ef" line
	*/

	$name = $name.".torrent";
	// check in all ps-arrays 
	while (list($key, $onepidstr) = each ($allpids))
	{
		if (stristr ($onepidstr, $name))
		{
			// extract first number (pid)
			preg_match("(\d+)", $onepidstr, $hit);
			return (int) $hit[0];
		}   
	}
	return 0;
}


function extract_updownload_history($history)
{
   $graph_string = "";
   $pos = 0;
   $pos1 = 1;

   while (true)
   {
     $pos1 = strpos ($history, 'MB |', $pos);
     $pos2 = strpos ($history, 'K/s |', $pos);
     $pos = $pos2 +1;
     if ($pos1 == 0) break;
     $graph_string = $graph_string.substr($history, $pos1+5, $pos2 - $pos1-5).";";
    }  
    return $graph_string;
}


function extract_stats($content)
{


  if (stripos($content, "exist") != 0)
  {
      $pos1 = strlen("Check exist: ");
      $pos2 = strpos ($content, '/');
      $segments_checked = (int) substr($content, $pos1+1, $pos2 - $pos1-1);
      $segments_total = (int) substr($content, $pos2+1);
   		$percent = (int) ($segments_checked / $segments_total *100);
//      echo substr($content, $pos1+1, $pos2 - $pos1-1), " - ", substr($content, $pos2+1);
    	return "<b>Resuming... Checking state: ".$percent."% done</b></br>";
  }
  else
  {
      	if  (strlen($content) < 34) 
      		return $content;

      	// check string for positions of seperator
      	$pos0 = strpos ($content, "[");
      	$pos1 = strpos ($content, "]", $pos0+1);
      	$pos2 = strpos ($content, '|', $pos1+1);
      	$pos3 = strpos ($content, '|', $pos2+1);
        
      	// Is something wrong with the status line e.g. string is much too short??
      	if  ($pos3  < 34) 
      		return $content;
      		
      
      	// cut substrings
      	$seeders =     substr($content, 3        , $pos0         - 3);
      	$segments =    substr($content, $pos0 + 1, $pos1 - $pos0 - 1);
        $updown =      substr($content, $pos1 + 1, $pos2 - $pos1 - 1);
        $updown_rate = substr($content, $pos2 + 1, $pos3 - $pos2 - 1);
      
      	// make one standard format using "; "
      	$seeders  = str_replace("/" , "; " , $seeders );
      	$updown  = str_replace("," , "; " , $updown );
      	$segments =   str_replace("/" , "; " , $segments );
      	$updown_rate  = str_replace("," , "K/s; " , $updown_rate );
      	
      
      	// Calc. progress from total segments to downloaded segments
      	$total = explode ("; ", $segments);
      	$percent_str = "percent: ";

      	if (((int) $total[1]) > 0)
      	{
      		$percent_str = $percent_str. (int) ((int) $total[0] / (int) $total[1] * 100);
      		if ($total[0] == $total[1])
      			$percent_str = $percent_str. "% - Seeding"; // if download is done to 100% seeding has to be done

      	}
      	else
      		return $content; // Is something wrong with the status line e.g. devision by zero??

      
//        if ($long_stat_status) // Long  Version
        {
      	// nice format long format
              
      	$formated_content= "<b>". $percent_str."</b></br>". 
       		"download-; upload rate: ".$updown_rate."</br>".
      		"seeders; leechers; peers: ".$seeders."</br>".
      		"current-; total-; avail.-pieces: ".$segments."</br>".
      		"total download; total upload: ".$updown;
       } 
//       else
//         $formated_content= "<b>". $percent_str." done.</b>";
      
     	return $formated_content;
        
   }
}



// function statsof($dir, $name)
function determine_torrent_state_phase2_and_history(&$torrents, $torrent_sum)
{
	/* 
	This function reads and formats the status file of the torrents.
  Collects the history and determines the state "seeding"
	*/
  global $absolute_path;
  
 // echo $torrent_sum->total;
 // print_r($torrents);
  
  for ($i = 0; $i < $torrent_sum->total; $i++)
	{

    if (!file_exists($absolute_path."/".$torrents[$i]->name.".stat") ||
         !filesize($absolute_path."/".$torrents[$i]->name.".stat") ) 
    {
	  	$torrents[$i]->stats = "-";
      $torrents[$i]->history = "";
    }
    else
    {    
      	if (false == ($handle = fopen ($absolute_path."/".$torrents[$i]->name.".stat", "rb")))
        {
    	  	$torrents[$i]->stats = "-";
          $torrents[$i]->history = "";
        }
        else
        {
          // extract META INFO
          $torrents[$i]->meta_info = "";
          while (true)
          {
            if (($line = fgets($handle)) === false) break;
            $torrents[$i]->meta_info = $torrents[$i]->meta_info.substr($line, 0, strlen($line)-1)."</br>";
            if (strpos ($line, "Total:") !== false) break;
          }  
        
          $temp=" ";  
          $pos = -2;
          
          $history_lines = 0;
          $last_line_pos = 0;
      
          while ($history_lines < 30*2 && feof($handle) != true) 
          {

           		if (fseek($handle, $pos, SEEK_END) === -1)
              {
                 fseek($handle, 0);                
                 break;
                 
               }
            	$temp = fgetc($handle); // read characters 
            	$pos = $pos - 1;
      
              if ($temp == "\n" || $temp == "\r" )
//              if ($temp == "\r" )
              { 
                $history_lines ++;
                if ($last_line_pos == 0)
                  $last_line_pos = $pos;
              }
          } 
          
          $history = fread($handle, abs($pos) ); //read all lines 
 
          fclose ($handle);
          
          //echo "</br>", $history ,"</br>";
          // extract history of up/download          
           $torrents[$i]->history = extract_updownload_history($history);
              
              $last_line = substr($history, $last_line_pos);  
        
              // extract history from last line
              
              $torrents[$i]->stats = extract_stats(substr($history, $last_line_pos));
              
        			if  ( !(strpos($torrents[$i]->stats, "-") === 0) && ($torrents[$i]->pid === 0) )
        				$torrents[$i]->state = 2;  // done
              
           	  if ($torrents[$i]->pid != 0)
              {
                if (strpos ($torrents[$i]->stats, "- Seeding") != 0)
                  $torrents[$i]->state = 5; 

              }

        }
    }
  }
 
}


//function get_torrent_state($dir, &$torrents, &$torrent_count, &$running_torrents, &$scheduled_torrents )

function determine_torrent_state_phase1(&$torrents, &$torrent_sum)
{
	/* 
	This function collects all torrents and tries to get the state of the torrents
	State 1 Loaded: No Pid, No Stat-File, only torrent File is available
	State 2 Running: Pid, Stat-File and torrent File are available
	State 3 Done: No Pid, Stat-File and torrent File are available
	State 4 Scheduled : torrent File are available
  State 5 Seeding: determine in phase 2
	*/
	
  global $absolute_path;
  
  
  // Get all scheduled torrents
	$all_scheduled = all_scheduled_torrents();

  // Get all available torrents in directory
	$folder = dir($absolute_path."/");
		      
	// Get all PIDs
	$allpids = all_pids_of_running_torrents();
  
  $torrent_sum->running = 0;
  $torrent_sum->total = 0;
  $torrent_sum->scheduled = 0;

	// search the given directory for torrents
	while ($entry = $folder->read()) 
	{
		if (preg_match("/\.torrent$/", $entry)) // search for torrents
		{
			// without .torrent at the end
			$name = substr ($entry, 0, - 8);

			$torrents[$torrent_sum->total] = new torrent_class();
			$torrents[$torrent_sum->total]->name = $name;
			$torrents[$torrent_sum->total]->state = 1; // loaded
			$torrents[$torrent_sum->total]->pid = pidof($allpids, $name); 

  	  if ($torrents[$torrent_sum->total]->pid != 0)
      {
		    $torrents[$torrent_sum->total]->state = 2;  // running
        $torrent_sum->running ++;
      }

      
      $i = 0;
    
      foreach ($all_scheduled as $content)
      {
        $i++;
        if (strpos($content, "'".$torrents[$torrent_sum->total]->name."'") !== FALSE)
        {
        				$torrents[$torrent_sum->total]->state = 4;  // Scheduled	
                $torrents[$torrent_sum->total]->schedule_nr	= $i;
                $torrent_sum->scheduled ++;
			  }
      }
			
      $torrent_sum->total++;
		}
	}
		
	$folder->close();
}



function display_start_button($name)
{
	echo "<form action=\"./torrent_start.php\"> <input type=\"button\" name=\"start\" value=\"start\" 
	onClick=\"self.location.href='./torrent_start.php?torrent=".$name."&action=start'\"> </form>";
}

function display_restart_button($name)
{
	echo "<form action=\"./torrent_start.php\"> <input type=\"button\" name=\"start\" value=\"start\" 
	onClick=\"self.location.href='./torrent_start.php?torrent=".$name."&action=start'\"> </form>";
}

function display_delete_button($name)
{
	echo "<form action=\"./torrent_delete.php\"> <input type=\"button\" name=\"delete\" value=\"delete\"
	onClick=\"self.location.href='./torrent_delete.php?torrent=".$name."'\"> </form>";
}


function display_stop_button($name, $pid)
{
	echo "<form action=\"./torrent_stop.php\"> <input type=\"button\" name=\"stop\" value=\"stop\"
	onClick=\"self.location.href='./torrent_stop.php?torrentpid=".$pid."&torrent=".$name."'\"> </form>";
}

function display_schedule_button($name)
{
	echo "<form action=\"./torrent_start.php\"> <input type=\"button\" name=\"schedule\" value=\"start\" 
	onClick=\"self.location.href='./torrent_start.php?torrent=".$name."&action=schedule'\"> </form>";

}


function display_del_schedule_button($name)
{
	echo "<form action=\"./torrent_schedule.php\"> <input type=\"button\" name=\"delschedule\" value=\"stop\" 
	onClick=\"self.location.href='./torrent_schedule.php?torrent=".$name."&action=delete'\"> </form>";
}

function check_scheduler_for_run() 
{
  global $max_torrents;
  global $scheduler_update;
  global $absolute_path;
      
  $running = FALSE;
	$allpids = explode ("\n", shell_exec("/bin/ps -ef | /bin/grep scheduler"));
  foreach ($allpids as $content)
     if (strpos($content, "scheduler.pl" ) !== FALSE)
        				$running = TRUE; // find scheduler 
                
  if ($running == FALSE)
  {
     $start =escapeshellcmd(realpath("./scheduler.sh")." ".$max_torrents." ".$absolute_path."/scheduled_torrents.txt ".$scheduler_update);
 
     system($start);
    
  }
               
}


function display_torrents($torrents, $torrent_sum)
{
	/* 
	This function displays the Torrent object via html
	*/
  
  //echo "<a href=\"index.htm\" onmouseover=\"return escape('Irgendein Text')\">Zur Startseite</a>";
  
  // globals from config file 
	global $absolute_path;
	global $web_path;
	global $max_torrents;
  global $bandwidth_down; 
  global $bandwidth_up;
  global $seed_hours;
  global $long_stat_status;
  global $diagramm_display;
    
	echo "<h2> Enhanced-CTorrent Control (ECTC) </h2>";	

  echo "<table border=\"1\" bgcolor=\"silver\" width=\"100%\"> <tr>";
  //echo "<th>Overall status: </th>";
  echo "<th>Torrents uploaded: ", $torrent_sum->total, "</th>";
  echo "<th>Torrents running: ", $torrent_sum->running, " of max. ",$max_torrents,"</th>";
  echo "<th>Torrents scheduled: ", $torrent_sum->scheduled, "</th>";
  echo "</tr></table>";
  

	echo "<table border=\"1\" bgcolor=\"silver\" width=\"100%\ >";
	echo "<tr bgcolor=\"silver\"> <th> Name </th> <th> State </th>  <th> Stats </th> <th> Control"; 
	echo "<form action=\"./torrent_stop.php\"> <input type=\"button\" name=\"stop_all\" value=\"stop all\"	onClick=\"self.location.href='./torrent_stop.php?torrentpid=0&torrent=all'\"> </form>";

  if ($diagramm_display == 1) 
    echo "</th> <th width=\"180\"> Graph ";
  
  echo "</th></tr>"; 

  
	for ($i = 0; $i < $torrent_sum->total; $i++)
	{
		if ($i % 2) // Lines shall have different colours
			echo "<tr bgcolor=\"aqua\" >";
		else
			echo "<tr bgcolor=\"lightblue\" >";

		// Display Link to- and name of torrent file
	//	echo "<td> <a href=\"", $web_path, "/", urlencode($torrents[$i]->name), "\">", $torrents[$i]->name," </a> </td>";
  
	  echo "<td> ";
    echo "<a href=\"".$web_path. "/ \" onmouseover=\"return escape('". $torrents[$i]->meta_info."')\">".wordwrap($torrents[$i]->name,40, "</br></t>", 1)."</a>";

    echo "</td>";
					
		// Display the torrent state also colourful
		if ($torrents[$i]->state == 1) 
			echo "<td bgcolor=\"",$torrents[$i]->status_colour(),"\"> ", $torrents[$i]->status() ,"</td>"; // Loaded
		else if ($torrents[$i]->state == 2) 
  			echo "<td bgcolor=\"",$torrents[$i]->status_colour(),"\"> ", $torrents[$i]->status() ,"</td>"; // Running
		else if ($torrents[$i]->state == 3) 
			echo "<td   bgcolor=\"",$torrents[$i]->status_colour(),"\"> ", $torrents[$i]->status() ,"</td>"; // done
		else  if ($torrents[$i]->state == 4) 
			echo "<td bgcolor=\"",$torrents[$i]->status_colour(),"\"> ", $torrents[$i]->status() ," #", $torrents[$i]->schedule_nr, "</td>"; // Scheduled
		else  if ($torrents[$i]->state == 5) 
			echo "<td bgcolor=\"",$torrents[$i]->status_colour(),"\"> ", $torrents[$i]->status() , ""; // Seeding


		// display the sttaus line
    
    if ($long_stat_status) // Long  Version
    {
     	// format long format
  		echo "<td><small> ", $torrents[$i]->stats, "</small></td>";
    }
    else
    {
      // with tooltip
      echo "<td><small>";

      
      //$first_line = substr($torrents[$i]->stats,0, strpos($torrents[$i]->stats, "</br>")); 
      $pos1 = strpos($torrents[$i]->stats, "</br>");
      
      $pos2 = strpos($torrents[$i]->stats, "</br>", $pos1+1);
      
      if ($pos2 > 0)
        $two_lines = substr($torrents[$i]->stats,0, $pos2);
      else
        $two_lines = substr($torrents[$i]->stats,0, $pos1);
           
      echo "<a href=\"\" onmouseover=\"return escape('". $torrents[$i]->stats."')\">".$two_lines."</a>";
      echo "</small></td>";
    }    
    
    
		// display the possible actions according to the torrent state
		echo "<td>";
		if ($torrents[$i]->state == 1) //A loaded torrent can be started or deleted
		{

			display_delete_button($torrents[$i]->name);

  		if ($torrent_sum->running < $max_torrents)
				display_start_button($torrents[$i]->name);
			else
				display_schedule_button($torrents[$i]->name);
	}
		else if ($torrents[$i]->state == 2 || $torrents[$i]->state == 5) //A running or seeding torrent can be stopped 
		{
			display_stop_button($torrents[$i]->name, $torrents[$i]->pid);
		}
		else if ($torrents[$i]->state == 3 ) //A "done" can be deleted and restarted
		{

			display_delete_button($torrents[$i]->name);

			if ($torrent_sum->running < $max_torrents)
				display_restart_button($torrents[$i]->name);
			else
				display_schedule_button($torrents[$i]->name);
		}
		else if ($torrents[$i]->state == 4) //A "scheduled" torrent can be stopped
		{
			display_del_schedule_button($torrents[$i]->name);
		}
    echo "</td>";
    
    //echo $torrents[$i]->history;
    if ($diagramm_display == 1) 
      echo "<td><img src=\"./diagramm.php?values=".$torrents[$i]->history."\" alt=\"\"></td>" ;   
      
   	echo "</tr>";
				
	}

	// Display the line with File upload button 
	echo "<tr bgcolor=\"silver\"> <td align=\"right\" >new Torrent via File</td> ";
	echo "<form enctype=\"multipart/form-data\" action=\"./torrent_upload.php?upload=start\" method=\"POST\">  
	      <td colspan=\"2\" align=\"left\" > <input name=\"uploadedfile\" type=\"file\" size=\"35\">";
	echo "</td><td>"; 
	echo "<input type=\"submit\" value=\"Upload File\" /></td> </tr> </form>";
  
	// Display the line with Http upload button 
	echo "<tr bgcolor=\"silver\"> <td align=\"right\" >new Torrent via URL</td> ";
	echo "<form enctype=\"multipart/form-data\" action=\"./torrent_httpload.php?upload=start\" method=\"POST\">  
	      <td colspan=\"2\" align=\"left\" > <input name=\"uploadedhttp\" type=\"text\" size=\"35\">";
	echo "</td><td>"; 
	echo "<input type=\"submit\" value=\"Upload URL\" /></td> </tr> </form>";
  
	// Display the line with WGET upload button 
	//echo "<tr bgcolor=\"silver\"> <td align=\"right\" >new Torrent via URL</td> ";
	//echo "<form enctype=\"multipart/form-data\" action=\"./wget_upload.php?upload=start\" method=\"POST\">  
	//      <td colspan=\"2\" align=\"left\" > <input name=\"uploadedhttp\" type=\"text\" size=\"35\">";
	//echo "</td><td>"; 
	//echo "<input type=\"submit\" value=\"Upload URL\" /></td> </tr> </form>";

    
  echo "<table border=\"1\" bgcolor=\"silver\" width=\"100%\"> <tr>";
  echo "<th> <a title=\"config\" href=\"./torrent_configuration.php\"> configuration </a> </th>";
  echo "<th>max. download rate:", $bandwidth_down, "KB/s</th>";
  echo "<th>max.  upload rate:", $bandwidth_up, "KB/s</th>";
  echo "<th>seed hours:", $seed_hours, "h</th>";
  echo "</tr></table>";  
	
}



// Mainloop 


determine_torrent_state_phase1($torrents, $torrent_sum);
determine_torrent_state_phase2_and_history($torrents, $torrent_sum);
display_torrents($torrents, $torrent_sum);

//get_torrent_state($absolute_path, $torrents, $torrent_count, $running_torrents, $scheduled_torrents);
//display_torrent_state($torrents, $torrent_count, $running_torrents, $scheduled_torrents);

check_scheduler_for_run(); 


// echo "<a title=\"Config\" href=\"./torrent_configuration.php\">Config</a>";

?>
<script language="JavaScript" type="text/javascript" src="wz_tooltip.js"></script>
</body>
