#!/usr/bin/perl

# $1 max. ctorrents
# $2 schedule file
# $3 scheduler update


if (@ARGV != 3)
{
	 die "parameter: max_ctorrents scheduler_file scheduler_update\n"
}  

$max_ctorrents = $ARGV[0];
$schedule_file = $ARGV[1];
$scheduler_update = $ARGV[2];

while (1)
{

	open(fh, "<$schedule_file") || die "nothing to do: file not found\n"; 
	$to_be_scheduled = 0;
	while(defined($line = <fh>)) 
	{
	  $torrent_names[$to_be_scheduled] = $line;
	  $to_be_scheduled = $to_be_scheduled + 1;
	}
	close(fh);
	
	# get number of running ctorrents


    	@info = `/bin/ps -ef | /bin/grep ctorrent`;
    	$running_torrents = @info; 
	if ( rindex ($info[$running_torrents-1], "grep") > 0)
	{
		# remove the grep itself
		$running_torrents = $running_torrents -1;
	}
       
        print "Torrents are working: $running_torrents\n";
        print "Torrents avail.  max: $max_ctorrents\n";
        print "Torrents to schedule: $to_be_scheduled\n";
    

	# if number of running ctorrnts less than max. ctorrents then
	if (($running_torrents < $max_ctorrents) &&
	    ($to_be_scheduled > 0))
	{
		print ("Start new Torrent   : $torrent_names[0] \n");

		# delete ctorrent from schedule file
		open(fh, ">$schedule_file") ;
		for ($i = 1; $i < $to_be_scheduled; $i++)
		{
	  		print fh $torrent_names[$i];
		}
		close(fh);

		system ( $torrent_names[0] );

	}
	
  #sleep
	sleep $scheduler_update;
}









